\section{Project Description}
\subsection{Introduction}\label{sec:intro}

Currently, routing ASICs (e.g. Brodcom Jericho2 \cite{Jerichodatasheet, Jerichotalk}, Cisco Silicon One \cite{SiliconOne}, etc) are designed in a RTL-level HDL, to the best of our knowledge \cite{CiscoAsic}. However, designing a hardware at RTL level is a very complex and tedious process. Here, designers need to use low level abstraction to implement the logic. The RTL code also needs to be cycle accurate. Thus, designers need to consider the path latency of the circuit and insert registers manually to implement pipelining. Such complex and tedious process calls for designing hardware at a higher level. High-level synthesis (HLS) \cite{coussy2009introduction} allows us to design a pipelined ASIC in a high-level language such as C or SystemC \cite{SystemC}. HLS tools generate RTL level hardware logic directly from programs implemented in high level languages  such as C or SystemC. This has major advantages over traditional RTL design, such as, increased designer productivity, better complexity management, shorter simulation cycle (no hardware/software codesign is needed), rapid design space exploration, higher quality of results (QoRs) and so on \cite{chen2005xpilot, evolutionhls, khailany2018modular}. Despite the benefits, HLS has not been adopted in switching and routing ASICs.

\subsection{High-level Synthesis for network processors}
Using HLS for routing chip is not new. Early routing chips were primarily developed using network processors. These include Cisco nPower \cite{cisconpower, wheeler2013new}, Juniper Trio \cite{JuniperTrio, hanks2012juniper}, Nokia FP \cite{NokiaFP}, EZchip NPS \cite{giladi2008network}. They used customized instruction set to optimize packet processing. The network processors are software programmable, thus offer greater flexibility. There are several high-level synthesis tools that were used to design the processor cores of network processors. These include Tensilica Xtensa \cite{tensilicatioIPForwarding, tensilicaxtensa} (now part of Cadence), Synopsys ASIP Designer \cite{synopsysasipdesigner} (used for Synopsys ARC core), Codasip \cite{codasipstudio} and so on. They take custom instruction-set and applications as inputs and generates processor core that supports that application and the instruction set. For example, Cisco QFP and nPower processor used Tensilica Xtensa \cite{tensilicatioIPForwarding, cisconpower}. 


\subsection{Emergence of ASIC as a router dataplane}
Even though network processors can achieve higher throughput than general purpose CPU, their throughput is still very limited (usually around $1$ Tb/s still to these days). Since around $2010$, pipelined ASICs have been emerged as an alternative to network processors for router dataplane. Router dataplane ASIC is a very hot industry trend at this moment \cite{ethernetasic}. The throughput of routing chips have been doubled in every two years in past ten years (grew from $640$ Gb/s in $2010$ to $25.6$ Tb/s in $2020$) \cite{Tomahawktalk}.
Example of pipelined ASIC include Brodcom Jericho (StrataDNX family) \cite{Jerichodatasheet, Jerichotalk, Arista7500R3, merchecntasiccisco}, Brodcom Trident (StrataXGS family) \cite{tridentdatasheet, merchecntasiccisco, Arista7050X3}, Brodcom Tomahawk (StrataXGS family) \cite{Tomahawk3, Tomahawk4, wheeler2019tomahawk, Tomahawktalk, merchecntasiccisco}, Barefoot Tofino (now part of Intel) \cite{bosshart2013forwarding, BarefootTofinotalk}, Cisco Silicon One \cite{SiliconOne, SiliconOnetalk}, Mellanox Spectrum (now part of Nvidia) \cite{MellanoxSpectrumdatasheet}, Innovium TERALYNX (now part of Marvell) \cite{InnoviumTERALYNXdatasheet}, Xsight Lab X1 \cite{XsightLabX1datasheet}, Nephos Tauras \cite{NephosTaurassheet}, Centec TsingMa \cite{centecTsingMa} and so on. These chips are used in data center switches, enterprise switches and service provider routers. There have been a convergence between switching and routing in last few years \cite{SiliconOne}. These chip can perform both layer $2$ and layer $3$ forwarding, thus can be considered as routing chip. 


\begin{figure}[!t]
	\centering
	\includegraphics[width=17cm]{asic-architecture}
	\caption{ \textcolor{blue}{Architecture of a fixed-function routing chip. Here, the architecture is similar to that of a Brodcom Tomahawk 4 (StrataXGS family) \cite{Tomahawk3, Tomahawk4, wheeler2019tomahawk, merchecntasiccisco, tridentdatasheet}. Here, ingress and egress pipelines are the focus of this proposal.}}\label{asic-architecture}
\end{figure}



\subsection{An overview of router dataplane ASIC}
 \textcolor{blue}{
Figure \ref{asic-architecture} shows a block diagram of a fixed function routing chip. Here, the example architecture is very similar to that of a $25.6$ Tb/s Brodcom Tomahawk 4 (StrataXGS family) \cite{Tomahawk3, Tomahawk4, wheeler2019tomahawk, merchecntasiccisco, tridentdatasheet}. The example routing chip consists of four modules: network interface, ingress pipeline, MMU and egress pipeline. We now discuss each module below.
}

 \textcolor{blue}{
\subsection{Network Interfaces}
The network interface uses SerDes (serializer-deserializer) IO modules to implement ports (sometimes also referred to as port macros). For instance, a $25.6$ Tb/s router can be implemented using $256$ SerDeses each of which supports $100$ Gbps. The example SerDeses can be broken into multiple port configurations such as $256 \times 100$GbE, $128 \times 200$GbE, $64 \times 400$GbE and $32 \times 800$GbE. A SerDes is responsible converting analog signals to digital bitstream (for receiption) and digital bitstream to analog signals (for transmission). It performs encoding, multiplexing, synchronization, clock recovery and serialization of the data on the wire. There are several standards for a SerDes such as Non-Return-to-Zero (NRZ), Pulse Amplitude Modulation (PAM) and so on. SerDeses are typically implemented by analog circuits, DSP or FPGA. There are several commercial SerDes IP vendors including Inphi, Keysight, Synopsys, Cadence, Marvell, Brodcom (formally Avago), Xilinx, Texas Instrument and so on. A network interface also turns the bitstream into frames/packets. It also performs lane mapping and forward error correction (FEC). Lane mapping involves grouping one or multiple SerDes to create a channel. For instance, $400$G channels are made by ganging together groups of four $100$G SerDes. If a packet/frame is received without error in a network interface, it is sent to an ingress pipeline. 
}


\begin {table}[H]
\caption {Example forwarding table (for IP lookup)} \label{lpm} 
\begin{center}
	\begin{tabular}{ | m{3cm} | m{3cm} |} 
		\hline Prefix & Next-hop\\
		\hline $169.254.0.0/16$ & $3$\\
		\hline $169.254.192.0/18$ & $4$\\		
		\hline $192.168.122.0/24$ & $5$\\						
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\begin {table}[H]
\caption {Example ruleset (for packet classification)} \label{classi} 
\begin{center}
	\begin{tabular}{ | m{1cm} | m{1.2cm} | m{1.2cm} | m{1.2cm}| m{1.2cm} | m{1.4cm}| m{1.2cm}|} 
		\hline Rule & SA & DA& SP & DP & Protocol & Action\\
		\hline r1 & $01100*$ & $01100*$ & $111$ & $111$ & 80 & forward\\
		\hline r2 & $11010*$ & $*$ & $10*$ & $11*$ & 22& drop\\
		\hline r3 & $*$ & $01111*$ & $000$ & $001$ & * & enqueue\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\subsection{Ingress Pipeline}
The ingress pipeline contains a parser that extracts source and destination IP addresses, port numbers, MAC addresses, protocol headers and so on. If the packet is a tunneled packet (e.g. MPLS, IPinIP, GRE,
VXLAN, MPLSoGRE) and is destined to a tunnel endpoint on this router, the packet is decapsulated to get the inner packet. The inner packet is the processed further. If the packet is a candidate for L2 switching, ethernet lookup is performed in the MAC table. On the other hand, if the packet is a candidate for L3 routing, routing table lookup is performed on the packet. This is how, the next-hop is found. Finally, packet classification is performed on the packet for flow classification, firewall and access control list (ACL).

Note that, performing both tunnel lookup and ethernet lookup involves performing a simple exact match. On the other hand, performing routing table lookup and packet classification require implementing longest prefix match (LPM) and exact/prefix match in multi-field ruleset respectively. Routing table lookup and packet classification are two of the most fundamental and expensive operation in a router. IP lookup involves performing the longest prefix match of the desination IP address. For instance, Table \ref{lpm} shows an example forwarding table of a router. If the destination IP address of an incoming packet is $169.254.198.1$, then the packet should be forwarded to next-hop $4$. Again, if the destination IP address is $169.254.190.5$, the packet should be forwarded to next-hop $3$. On the other hand, packet classification involves finding the best match for a packet in a multi-field ruleset to determine the action. Table \ref{classi} shows an example ruleset of a router. Here, the rules in the ruleset consist of a source address (SA), a destination address (DA), a source port (SP), a destination port (DP) and a protocol field. Each rule in the ruleset also has a priority. Here, we can have exact or prefix match. \footnote{Packet classification rules can also have range match (e,g. $20-50$). However, a range can be represented as one or multiple prefixes \cite{li2019tabtree}.} A packet may match with more than one rules. In that case, rules with higher priority determines the action.

IP lookup and packet classification in routing chips mainly fall into two categories: TCAM and pipelined ASIC based solutions. TCAM is very expensive, area-inefficient and power hungry. It also requires very complex incremental update. On the other hand, pipelined ASIC utilizes on-chip SRAM which is cheaper and consumes less power. Pipelined ASIC can implement various algorithmic solutions of IP lookup and packet classification. In this proposal, we focus on ASIC-based IP lookup. We also implemented a packet classification algorithm in this proposal.

\subsection{MMU}
After processed by the ingress pipeline, the packet is stored in a shared data buffer. The size of the buffer varies based on the router. For instance, core routers generally need a large buffer whereas data center routers need a small buffer. The memory management unit (MMU) has scheduler (also known as traffic manager) which is responsible for queuing, heavy-hitter detection, explicit congestion control and so on. When the packet is ready to be sent by the scheduler, it is sent to the egress pipeline.

\subsection{Egress Pipeline} 
Egress pipeline parses the packet again and performs packet classification (for ACL and firewall). It also decrements the TTL and rewrites the source and destination MAC address before transmitting the packet to through the MAC. 

\begin {table}[H]
\caption {Performance of a typical $25.6$ Tb/s routing chip} \label{chip_performance} 
\begin{center}
	\begin{tabular}{ | m{3cm}| m{8cm}|}
		\hline Forwarding rate & Undisclosed (likely around $38$ Bpps) \cite{zilberman2019stardust, Arista7500R3, Arista7050X3} \\
		\hline ASIC clock speed & $1$ GHz \cite{zilberman2019stardust} \\
		\hline Power & $300-600$ W \cite{tsakyridis202025, XsightLabX1datasheet, wheeler2019tomahawk}\\
		\hline Area & around $800$ $mm^2$ \cite{SiliconOnetalk, zilberman2019stardust} \\
		\hline Latency (L3) & $450-800$ ns \cite{tsakyridis202025, XsightLabX1datasheet, wheeler2019tomahawk}\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

 \textcolor{blue}{
\subsection{Routing chip IPs}
Routing chips are developed using hardware description languages (HDL) such as Verilog or VHDL. Those HDL implementations are refereed to as intellectual property (IP). Note that, this IP is different from IPs in networking stack. A routing chip has several crucial building blocks each of which are often developed by different vendors. For instance, network interface is often developed by a SerDes vendor and MMU is developed by memory vendors. A typical routing chip vendor mainly focuses on ingress and egress pipeline. They include external network interface and MMU IP into the final design. In this proposal, we will mainly focus on ingress and egress pipeline. In ingress and egress pipeline, routing table lookup and packet classifications are two of the most critical operations. Packet parser, tunnel lookup and ethernet lookup are typically simpler to design compared to routing table lookup and packet classification. In this proposal, we will mainly focus on routing table lookup. We also discuss packet classification in this proposal.
}

\subsection{Performance of a typical routing chip}
A $25.6$ Tb/s router needs to forward around $11.6$ billion packets per second (Bpps) ($\frac{\frac{25.6 * 10^{12} }{8}}{256 + 8 + 12}$) for $256$B packets (a packet will also require $8$ bytes frame header and $12$ bytes frame interval) \cite{zilberman2019stardust}. Again, for $64$B packets, it will need to forward around $38.1$ billion packets per second ($\frac{\frac{25.6 * 10^{12} }{8}}{64 + 8 + 12}$). However, a routing chip's clock speed is typically around only $1$ GHz \cite{zilberman2019stardust}. A $1$ GHz pipeline ASIC can only process $1$ billion packets per second ($1$ packet in every $1$ ns). This is why, routing chip typically uses multiple pipelines. Here, multiple pipelines are analogous to CPU cores in a multi-core CPU. If a routing chips has $20$ pipelines each of which is $1$ GHz, then it can process upto $20$ billion packets per second. Currently, Brodcom Tomahawk 4, Innovium TERALYNX 8 and Xsight X1 are industry's highest throughput routing chips. They support $25.6$ Tb/s. There have been very little information available for these chips. Table \ref{chip_performance} shows the performance of a typical $25.6$ Tb/s. These chips are developed in TSMC’s $7$ nm process technology.

\subsection{Current Status of HLS research for routing ASIC}
A routing chip differs from traditional chips in two ways. Firstly, it needs to support pipelining so that it can process packets at line rate. A routing chip may need to process several billion packets per second. Secondly, a routing chip needs to implement control flow intensive applications because many router applications such as IP lookup and packet classification algorithms needs to implement many nested conditional statements. There have been very few work on high-level synthesis for routers. SWSL \cite{kim2013swsl} was the first attempt towards this approach. But, SWSL is not open source and appears to be abandoned at this moment. We have developed a high-level synthesis tool named C2RTL \cite{tamimc2rtl} for router chips. We open sourced our implementation (https://tamimcse.github.io/c2rtl/). The details would be found in \cite{tamimc2rtl}. C2RTL takes a C code as an input and generates corresponding Verilog code for pipelined ASIC. We evaluated C2RTL for several IP lookup algorithms (e.g. SAIL \cite{yang2014guarantee}, Poptrie \cite{asai2015poptrie}, CP-Trie \cite{tamimcptrie}) and packet classification algorithms (e.g. TabTree \cite{li2019tabtree}). We evaluated the generated Verilog code with iVerilog simulator. We also generated physical chip layout from the generated Verilog code with $45$nm Nandgate Open Cell Libray using OpenROAD \cite{ajayi2019toward}. This enabled us to evaluate Power-Performace-Area (PPA) for various IP lookup and packet classification algorithms for ASIC.

It is noteworthy that we implemented several existing IP lookup \cite{yang2014guarantee, asai2015poptrie} and packet classification  \cite{li2019tabtree} algorithms in ASIC which were never been evaluated on ASIC before. Having a high-level synthesis tool such as C2RTL enabled this. We also developed a new IP lookup algorithm named CP-Trie \cite{tamimcptrie} that outperforms the state-of-the-art IP lookup algorithms. Thus, C2RTL will spur research in both high-level synthesis and high-speed routers. 


\subsection{Limitations of C2TL}
C2RTL is aimed to generate various intellectual property (IP) blocks for routing ASICs. However, more works need be done to achieve the goal. Currently, it has two following limitations.

\begin{itemize}
	\item \textbf{Using a fixed resource for each operation.} Currently, C2RTL mainly focuses on implementing pipelined ASIC. It divides the behavioral description into several pipeline stages where each pipeline stage can be executed in $1$ns to achieve $1$ GHz clock speed. Here, each operation is implemented by a fixed resource (similar to Bambu \cite{pilato2013bambu}). This is however a simplistic assumption. An instruction can have multiple resource implementations in a standard cell library. And, there is a trade-off between delay and area among multiple implementations. For instance, Table \ref{delay-area-tradeoff} shows area and delay trade-off for an adder in TSMC $90$nm standard cell library \cite{kondratyev2012exploiting}. It shows that increasing latency reduces area (and power). Note that, power consumption of a chip is proportional to its area \cite{kim2015automated}. This is why, we mainly focus on area, but it is applicable to power as well. It is possible to consider multiple resources to develop area/power efficient pipelining.
	
	\item \textbf{Limited dataplane function support.} Currently, C2RTL works for trie based IP lookup and packet classification algorithms. However, a router needs to implement many other dataplane functions such as ethernet lookup, header parsing, scheduling and so on.	
\end{itemize}

\subsection{Overview of Proposed Activities}
We propose following two features to be developed in C2RTL:

\begin{itemize}
	\item \textbf{Area/Power efficient pipelining:} This project aims to develop an automated pipelining algorithm that reduces area without violating timing constraint. This problem was initially investigated in \cite{kondratyev2012exploiting, kim2015automated}. We will discuss the problem in details in the next section.
	
	\item \textbf{Broader data-plane function support:} Currently, C2RTL works for trie based IP lookup and packet classification algorithms. We aim to support other dataplane functions, such as, ethernet lookup \cite{kim2013swsl}, queuing \cite{sivaraman2015towards}, router-assisted congestion control \cite{islam2017network, tamimrcp}, heavy-hitter detection \cite{sivaraman2016packet}, hash based IP lookup and packet classification algorithms \cite{pong2011concise, li2020tuple} and so on.
\end{itemize}



\begin {table}[t]
\caption {Area and delay trade-offs for an adder} \label{delay-area-tradeoff} 
\begin{center}
	\begin{tabular}{ | m{1.8cm}| m{.5cm}| m{.5cm}| m{.5cm} | m{.5cm} | m{.5cm} | m{.6cm} |}
		\hline Delay (ps) & $220$ & $400$ & $580$ & $760$ & $940$ & $1220$\\
		\hline Area & $556$& $254$ & $225$ & $216$ & $210$ & $206$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}


 	
\begin{figure}[!t]
	\centering
	\includegraphics[width=9cm]{register-insertion}
	\caption{ \textcolor{blue}{Block diagram of a pipelined ASIC}}\label{register-insertion}
\end{figure}



\subsubsection{Pipelining}
 \textcolor{blue}{
Pipelining involves partitioning a circuit into multiple stages. Figure \ref{register-insertion} shows a block diagram of a pipelined ASIC. Here, a circuit is partitioned into multiple pipeline stages. Each pipeline stage is implemented by a combinational circuit. The latency of a combinational circuit has to be smaller than  clock cycle. Output of each combination circuit is stored in a register. There registers are linked to a clock. In every clock cycle, data moves from one pipeline stage to the next stage. Thus, pipelining of circuit is actually a register insertion problem.
}

\begin{figure*}[!t]
	\begin{subfigure}[t]{\textwidth}
		\centering
		\includegraphics[width=8cm]{pipeline-terms1}
		\caption{Example circuit}\label{pipeline-terms1}
	\end{subfigure}%
	
	\begin{subfigure}[t]{\textwidth}
		\centering
		\includegraphics[width=16cm]{pipeline-terms2}
		\caption{Execution of a pipeline}\label{pipeline-terms2}
	\end{subfigure}%
	\caption{Example pipeline with Initiation Interval (II) = $1$ and Latency = $3$ cycle}\label{pipeline-terms}
\end{figure*}



\subsubsection{Pipelining terminologies}
This subsection describes different terminologies regarding pipelining. There are three key parameters of a pipeline: 1. \textbf{clock cycle}, 2. \textbf{Initiation Interval (II)} and 3. \textbf{Latency}. Figure \ref{pipeline-terms} shows an example pipeline with Initiation Interval (II) = $1$ and Latency = $3$ cycle. Here, the circuit is divided into three pipeline stages. Each pipeline stage needs to be executed in a single clock cycle. Thus, latency of the circuit is same as the number of clock cycles needed ($3$ in this case). Here, the initiation interval is $1$ which indicates that the pipeline start processing new data in every clock cycle. In order to process inputs at line rate, initiation interval needs to $1$. The throughput of this is circuit is same as the clock frequency. Thus, if the clock cycle of the pipeline ASIC is $1$ ns, the clock frequency is $1$ GHz. That is, the circuit can process $10^9$ inputs every second. These terminologies are widely used in existing high-level synthesis systems \cite{book2010mentor}.

A routing chip needs to process packets at line rate. This is why, they use Initiation Interval (II) = $1$. Clock speed of routing ASIC is generally kept at $1$ GHz \cite{zilberman2019stardust}, thus the clock cycle is $1$ ns.  


\begin{figure}[!t]
	\centering
	\includegraphics[width=18cm]{new-pipeline}
	\caption{Four arbitrary pipelining options of the same circuit (CDFG)}\label{new-pipeline}
\end{figure}

\begin{table}[]
	\centering
	\caption{Available resources to implement \textit{adder}, \textit{multiplier}, \textit{left shifter}, \textit{comparator} and \textit{multiplexer}}
	\label{resources}
	\begin{tabular}{|l|l|l|l|l|l|}
		\hline
		\multirow{2}{*}{Add} & Delay (ps) & 220 & 400  & 580 & 810 \\ \cline{2-6} 
		& Area & 556 & 400 & 300 & 150 \\ \hline
		\multirow{2}{*}{Mul} & Delay (ps) &  250 & 450 & 600 & 850 \\ \cline{2-6} 
		& Area & 810 & 600 & 360 & 195 \\ \hline
		\multirow{2}{*}{Left shift} & Delay (ps) & 100 & 210 & 250 & 465 \\ \cline{2-6} 
		& Area & 300 &  210 & 100 & 50 \\ \hline
		\multirow{2}{*}{Comparator} & Delay (ps) & 50 & 140 & 200 & 300 \\ \cline{2-6} 
		& Area & 200 &  150 &  100 & 75 \\ \hline
		\multirow{2}{*}{Mux} & Delay (ps) &  200 &  250 &  400 & 650 \\ \cline{2-6} 
		& Area & 500 &  400 &  250 & 200 \\ \hline
	\end{tabular}
\end{table}



\subsubsection{Area/power efficient pipelining}
This section  describes area/power efficient pipelining by combining \textit{resource allocation} and \textit{scheduling} algorithm. We first describe the problem of \textbf{resource allocation} and \textbf{scheduling} with an example. Figure \ref{new-pipeline} shows four \textbf{arbitrary} pipelining configurations of a circuit. Here, the latency of the circuit is $3$ clock cycle, thus the circuits are divided into $3$ pipeline stages. Diving a circuit into multiple pipeline stages is known as \textbf{scheduling}. On the other hand, selecting a resource to implement an operation is known as \textbf{resource allocation}. Here, the circuit needs adder, multiplier, left shifter, comparator and multiplexer. Table \ref{resources} shows an example available resources to implement the operations. Let us assume that clock cycle is $1$ ns. If we use the slowest (and thus most area/power efficient) resource, it may violate timing constant. For instance, the case 1 of Figure \ref{new-pipeline} has two paths in pipeline stage $1$. One path contains a left shift and an adder, thus path latency is $810 + 665$ (for the slowest resource) which exceeds the clock cycle. Another path contains two left shifters and a multiplier, thus path latency is $665 + 665 + 850$ (for the slowest resource) which also exceeds the clock cycle. Thus, simply using the slowest resource may violate the timing constraint. Again, using the fastest resource for each operation may meet the timing constraints, however it will result in very large area. The objective of the resource allocation algorithm is to find the optimal resource allocation for each operation such that area is minimized without violating the timing constraint. Also note that, we need to consider this for all possible pipelining cases, not just one pipeline configuration. Thus, our \textbf{combined resource allocation and scheduling} algorithm needs to find an optimal pipeline configuration and optimal resource assignment such that area is minimized and timing constraint is met.


\begin {table}[H]
\caption {\textcolor{blue}{Resource allocation options where path latency is less than $1$ ns (latency requirement)} for stage $1$ in case $1$ in Figure \ref{new-pipeline} } \label{resourec_allocation_case1_stage1} 
\begin{center}
	\begin{tabular}{ | m{14cm} |  m{1cm} | }
		\hline Resource along with latency & Area\\
		\hline Add(400) + Left-shift (465), Left-shift (210) + Left-shift (100) + Mul (600) & $1320$ \\
		\hline Add(580) + Left-shift (250), Left-shift (210) + Left-shift (100) + Mul (600) & $1280$ \\
		\hline Add(810) + Left-shift (100), Left-shift (210) + Left-shift (100) + Mul (600) & $1320$ \\
		\hline Add(400) + Left-shift (465), Left-shift (250) + Left-shift (250) + Mul (450) & $1250$ \\
		\hline Add(580) + Left-shift (250), Left-shift (250) + Left-shift (250) + Mul (450) & $1200$ \\
		\hline Add(810) + Left-shift (100), Left-shift (250) + Left-shift (250) + Mul (450) & $1250$ \\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\begin {table}[H]
\caption {\textcolor{blue}{Optimal resource allocation for case $1$ in Figure \ref{new-pipeline}. Here, the path latency of each stage is less than $1$ ns, thus latency requirement is met and area is minimized.}} \label{resourec_allocation_case1} 
\begin{center}
	\begin{tabular}{|  m{2cm}  | m{12.5cm} |  m{.8cm} | }
		\hline & Resource along with latency & Area\\
		\hline Stage 1 & Add(580) + Left-shift (250), Left-shift (250) + Left-shift (250) + Mul (450) & $1200$ \\
		\hline Stage 2 & Add(580) + Left-shift (250), Comparator (300), Add (400) + Add (580) & $1175$ \\
		\hline Stage 3 & Add(220) + Mul (250) + MUX (250), Mul (600) + MUX (250) & $2126$ \\
		\hline \textbf{Total area} &  & $4501$ \\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\begin{table}[]
	\centering
	\caption{Optimal resource allocation for different pipeline options}
	\label{resource-allocation-scheduling}
	\begin{tabular}{|  m{1cm}  | m{2cm} |  m{13cm} | m{.8cm} | }
		\hline
		\multirow{2}{*}{Case 1} & Stage 1 & Add(580) + Left-shift (250), Left-shift (250) + Left-shift (250) + Mul (450) & $1200$   \\ \cline{2-4} 
		& Stage 2 & Add(580) + Left-shift (250), Comparator (300), Add (400) + Add (580) & $1175$  \\ \cline{2-4}
		& Stage 3 & Add(220) + Mul (250) + MUX (250), Mul (600) + MUX (250) & $2126$  \\ \cline{2-4}
		& \textbf{Total area} &  & $4501$  \\ \hline
		\multirow{2}{*}{Case 2} & Stage 1 & Left-shift (465), Left-shift (250) + Mul (600) & $510$   \\ \cline{2-4} 
		& Stage 2 & Add (400) + Add (220) + Add (220) + Left-shift (100) + Left-shift (250), Comparator (300), Add (220) + Add (220) + Mul (450) & $3699$  \\ \cline{2-4}
		& Stage 3 & Mul (600) + MUX (400) & $610$  \\ \cline{2-4}
		& \textbf{Total area} &  & $4819$  \\ \hline
		\multirow{2}{*}{Case 3} & Stage 1 &  Add(580) + Left-shift (250), Left-shift (250) + Left-shift (250) + Mul (450) & $1200$    \\ \cline{2-4} 
		& Stage 2 &  Add(580) + Left-shift (250), Comparator (300), Add (810) & $625$   \\ \cline{2-4}
		& Stage 3 &  Add(220) + Mul (250) + MUX (250), Add(220) + Mul (250) + MUX (250) & $3532$   \\ \cline{2-4}
		& \textbf{Total area} &  & $5357$  \\ \hline
		\multirow{2}{*}{Case 4} & Stage 1 &  Add(580) + Left-shift (250), Left-shift (250) + Left-shift (250) + Mul (450) & $1200$  \\ \cline{2-4} 
		& Stage 2 & Add (400) + Left-shit (250) + Add (220), Comparator (300), Add (400) + Add (580)  & $1831$  \\ \cline{2-4}
		& Stage 3 &  Mul (600) + MUX (400) Mul (600) & $970$    \\ \cline{2-4}
		& \textbf{Total area} &  & $4001$ \\ \hline
	\end{tabular}
\end{table}

Note that, both scheduling and resource allocation algorithms are mutually dependent. Existing high level synthesis systems implement resource allocation and scheduling sequentially. They first implements resource allocation algorithm. It then performs scheduling algorithm. This approach may result small area, however it will increase the number of pipeline stages (thus latency). If there is a latency constraint, we need to solve the resource allocation and scheduling together. Table \ref{resourec_allocation_case1_stage1} shows the different resource allocation options for stage $1$ of case $1$ (in Figure \ref{new-pipeline}). All of these resource allocation options meet the timing constraint, however they result in different areas. Here, the minimum area is $1200$ which is the optimal resource allocation for that pipeline stage. In the same way, we can find the optimal resource allocation for each pipeline stage. Table \ref{resourec_allocation_case1} shows the optimal resource allocation for case 1 in Figure \ref{new-pipeline}. Here, the total area is $4501$. This is how, we can find area for the other cases in Figure \ref{new-pipeline}. Table \ref{resource-allocation-scheduling} shows the resource allocation for different pipelining (scheduling) cases of Figure \ref{new-pipeline}. It shows that, different pipeline options will require very different types of resource to meet the timing constraint. Table \ref{resource-allocation-scheduling} also shows that case $4$ results in the smallest area among the four cases. Our combined resource allocation and scheduling algorithm needs to find out the pipelining that results the lowest area. 

There can be exponential number of possible pipeline configurations and each pipeline configuration can have several possible resource allocation strategy. This is why, the problem space of this problem is exponentially large. The problem can be even more complicated if we consider \textbf{resource sharing}. Resource sharing allows us to use same resource to implement multiple operation in the same pipeline stage. Currently, we do not consider resource sharing. To make the problem worse, actual latency and area/power utilization of a pipeline configuration cannot be known until performing actual logic synthesis to generate netlist which itself is a very time consuming process. This is why, existing RTL synthesis tools such as Synopsys Design Compiler generally first performs scheduling with the fastest resource. They then try to improve the area by moving operations between different pipeline stages. Kim et. al. \cite{kim2015automated} proposed several heuristics to find the optimal resource allocation strategy. However, their solution was primarily developed for data-flow intensive applications, not for control flow intensive applications. Finally, Kondratyev et. al. \cite{kondratyev2011realistic} proposed an approach where they find the most critical operation by evaluating the behavioral timing analysis. Their approach has been integrated with Cadence Stratus high-level synthesis tool. However, area saving with this approach is very minimal. Several researches have investigated the problem for FPGA \cite{ferrandi2010ant, ganusov2016automated}.


%Currently, C2RTL uses a fixed resource to implement each operation such that latency is minimized. New resource allocation algorithm will allow us to generate area and power efficient implementation without violating the timing constraint.



\begin {table}[H]
\caption {programming restrictions in C2RTL} \label{program_restrictions} 
\begin{center}
	\begin{tabular}{ | m{12cm}|}
		\hline No loop (while, for, do-while)\\
		\hline No unstructured control flow (goto, break, continue) \\
		\hline No ternary operation \\
		\hline No dynamic memory allocation\\
		\hline No global variables\\
		\hline No structure\\
		\hline No switch\\
		\hline No function call\\
		\hline Each branch has to have a separate return statement\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table}

\begin {table*}[t]
\caption {Router data plane functions} \label{dataplanefunctions} 
\begin{center}
	\begin{tabular}{ | m{5cm}| m{9cm}|}
		\hline Algorithm & Function \\
		\hline CP-Trie \cite{tamimcptrie} & It performs IPv6 routing table lookup. \\
		\hline Poptrie \cite{asai2015poptrie} & It performs IPv6 routing table lookup \\
		\hline SAIL \cite{yang2014guarantee} & It performs IPv6 routing table lookup \\
		\hline TabTree \cite{li2019tabtree} & It performs packet classification (firewall). \\
		\hline RCP \cite{islam2017network, tamimrcp} & It is a router-assisted congestion control algorithm.\\
		\hline  Count-Min Sketch \cite{sivaraman2015towards} & It is used for heavy-hitter detection\\
		\hline  Hash-based exact match \cite{sivaraman2015towards} & It is used for ethernet lookup\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table*}

\subsection{Broader data-plane function support}
An input program in C2RTL is implemented in C language, but with several restrictions (Table \ref{program_restrictions}). Although C allows us to implement an algorithm in different ways, C2RTL requires us to adhere to a programming convention. These restrictions allow us to produce intermediate code (via GCC compiler) in a specific format. Note that, other HLS tools often impose similar restrictions \cite{book2010mentor, pilato2013bambu}. 

We would like to evaluate our proposed algorithm with wide range of router dataplane algorithms shown in Table \ref{dataplanefunctions}.  We already have implemented CP-Trie, Poptrie, SAIL and TabTree in C2RTL. We will need to implement RCP, Count-Min Sketch and Hash-based exact match in C2RTL as well. We will implement those algorithms in C and then generate corresponding Verilog RTL code using C2RTL. Here, we need to investigate the C language constructs that are needed to implement the algorithms. 


\begin{figure}[!t]
	\centering
	\includegraphics[width=8cm]{hls-flow}
	\caption{C code to physical chip layout generation}\label{hls-flow}
\end{figure}

\begin {table*}[t]
\caption {Power, area and timing in ASIC} \label{powerconsumption_openroad} 
\begin{center}
	\begin{tabular}{ | m{3cm}| m{2.6cm}| m{2.6cm}| m{2.6cm} | m{2.6cm} |}
		\hline  & Poptrie & SAIL & CP-Trie & TabTree\\
		\hline Clock speed & $1$ GHz & $1$ GHz & $1$ GHz & $1$ GHz \\
		\hline Internal Power & $76.5$ mW & $0.722$ mW & $64.6$ mW & $0.033$ mW\\
		\hline Switching Power & $24.4$ mW & $0.229$ mW & $22.2$ mW & $0.0054$ mW\\
		\hline Leakage Power & $1.15$ mW & $0.0108$ mW & $0.926$ mW & $0.00061$ mW\\
		\hline Total Power & $102.05$ mW & $0.961$ mW & $87.726$ mW & $0.0391$ mW\\
		\hline Area & $0.0658$ $mm^2$ & $0.00061$ $mm^2$ & $0.0523$ $mm^2$ & $0.000034$ $mm^2$\\
		\hline 
	\end{tabular} 	
\end{center}
\end {table*}

\subsection{Evaluation and Preliminary Results}
We will use OpenROAD \cite{ajayi2019toward} to generate physical chip layout. OpenROAD also generates the power and area. Here, we will use $45$nm Nandgate Open Cell Library. Figure \ref{hls-flow} shows our C code to physical synthesis flow. In our earlier work, we used OpenROAD and $45$nm Nandgate Open Cell Library to generate the power and area of CP-Trie, Poptrie, SAIL and TabTree Verilog implementation that was generated by C2RTL (Table \ref{powerconsumption_openroad}). In the similar manner, we will generate optimal power and area for other data plane functions shown in Table \ref{dataplanefunctions}. We will also use the dataplane functions as a benchmark for our resource allocation algorithm.

\subsection{Broader Impact of the Proposed Work}
Routing chip is the key component of a modern router that runs the Internet. Currently, developing a routing chip requires thousands of man years. Currently, most of routing chips (e.g. Brodcom Jericho2 \cite{Jerichodatasheet, Jerichotalk}, Cisco Silicon One \cite{SiliconOne}, etc) are designed in a RTL-level HDL, to the best of our knowledge. However, developing a chip in RTL-level HDL is extremely challenging. It requires thousands of hardware designers for years to develop a new routing chip. As a result, there is a bifurcation between academia and industry. Most of the academic researchers do not have the resources to implement their novel algorithms in ASIC. This calls for a new routing ASIC development methodology. C2RTL can be a solution to this problem. It allows us to design an algorithm in C and generates corresponding Verilog RTL. This improves the productivity significantly. It will allow software developers and networking researchers to develop their novel dataplane algorithm in C and generate corresponding Verilog code. Thus, C2RTL will remove the barrier of routing ASIC development by providing an open source HLS tool for routers. This will improve the hardware and networking research ecosystem significantly. It will also lower the cost of ASIC development by improving designer productively. C2RTL will also play a critical role in power efficient routing ASIC development.

\textbf{Education and Outrich.}
The students working on this project will gain hands-on experience on developing High-level synthesis and router dataplane algorithms. The project will also develop curricular material to train graduate students in high-level synthesis and high-performance routers. We will make the source code publicly available on Github. We will publish all the research finding in peer-reviewed conferences to disseminate the ideas with research community. 

\begin{comment}

\begin{figure}
%    \centering
\begin{ganttchart}[%Specs
	y unit title=0.5cm,
	y unit chart=0.7cm,
	vgrid,hgrid,
	title height=1,
	%     title/.style={fill=none},
	title label font=\bfseries\footnotesize,
	bar/.style={fill=blue},
	bar height=0.7,
	%   progress label text={},
	group right shift=0,
	group top shift=0.7,
	group height=.3,
	group peaks width={0.2},
	inline]{1}{24}
	%labels
	\gantttitle{A two-years project}{24}\\  % title 1
	\gantttitle[]{2022}{6}                 % title 2
	\gantttitle[]{2023}{12}                 % title 2
	\gantttitle[]{2024}{6} \\              
	\gantttitle{Q3}{3}                      % title 3
	\gantttitle{Q4}{3}
	\gantttitle{Q1}{3}
	\gantttitle{Q2}{3}
	\gantttitle{Q3}{3}
	\gantttitle{Q4}{3}
	\gantttitle{Q1}{3} 
	\gantttitle{Q2}{3}\\
	% Setting group if any
	\ganttgroup[inline=false]{Resource Allocation}{1}{24}\\ 
	%\ganttbar[progress=10,inline=false]{Planning}{1}{4}\\
	%\ganttmilestone[inline=false]{Milestone 1}{9} \\
	
	\ganttgroup[inline=false]{Dataplane Function}{4}{24} \\ 
	%\ganttbar[progress=2,inline=false]{test1}{10}{19} \\
	%\ganttmilestone[inline=false]{Milestone 2}{17} \\
	%\ganttbar[progress=5,inline=false]{test2}{11}{20} \\
	%\ganttmilestone[inline=false]{Milestone 3}{22} \\       
	
	\ganttgroup[inline=true]{Collaboration in KSU}{1}{24} \\ 
	
	\ganttgroup[inline=true]{Collaboration with Industry}{13}{24} \\
	%\ganttbar[progress=90,inline=false]{Task A}{13}{15} \\ 
	%\ganttbar[progress=50,inline=false, bar progress label node/.append style={below left= 10pt and 7pt}]{Task B}{13}{24} \\ \\
	%\ganttbar[progress=30,inline=false]{Task C}{15}{16}\\ 
	%\ganttbar[progress=70,inline=false]{Task D}{18}{20} \\ 
\end{ganttchart}
    \caption{Project Timeline}\label{timeline}
\end{figure}

\end{comment}

\subsection{Project Management \textcolor{blue}{This should not be changed, I think. I saw few successful CS SMALL grant applications, and following descriptions are pretty standard. For larger projects, it is makes sense to breakdown different parts. But for a small project, we just need to describe HOW we manage the project}}
This will be a two-year project. The systems will be developed and tested on a high performance laptop with Intel(R) Core (TM) i9 processor and $16$ GB DRAM running Linux operating system. We will divide the project in two groups. One group will be responsible for researching and developing area/power efficient pipelining. Another group will be responsible for adding broad range of dataplane function support.

While the quality and the quantity of the publications generated by this research provide an objective evaluation of its success, we plan to conduct a well-designed survey to academic and industry collaborators who use C2RTL. Their feedback can expose the its weakness for further improvement. A system website will be maintained on the departmental server and all the code will be released on Github for public use. A mailing list will be setup for the users of the system to ask questions and report bugs. The outcomes of this grant will assist us in the future grant applications in CISE to sustain a long term research career.     

\subsection{Results from Prior NSF Support}
MD Iftakharul Islam (https://tamimcse.github.io/) is a PhD candidate at the Department of Computer Science, Kent State University. He is doing research on Router Dataplane Algorithms and High-Level Synthesis. He is going to work as a software engineer for Juniper Network. Professor Javed I. Khan is the supervisor of MD Iftakharul Islam. He is the chair of the department of Computer Science, Kent State University. MD Iftakharul Islam and Javed I. Khan have published five papers relevant to this proposal \cite{tamimc2rtl, tamimcptrie, tamimsail, tamimrcp, islam2017network}.  They have not received any grant on these research.

